require 'spec_helper'
module G5YglClient20
  describe Client do

    let(:client) {G5YglClient20::Client.new("shinyandchrome", "aquacola", 3, 44, 666)}

    describe "initialize" do
      it "assigns" do
        client.instance_variable_get(:@auth).should eq("BASIC c2hpbnlhbmRjaHJvbWU6YXF1YWNvbGE=")
        client.instance_variable_get(:@url).should eq("https://www.youvegotleads.com/api/properties/")
        client.instance_variable_get(:@subscription_id).should eq(3)
        client.instance_variable_get(:@source_id).should eq(44)
        client.instance_variable_get(:@sub_source_id).should eq(666)
      end
    end

    let(:url) {"https://www.youvegotleads.com/api/properties/"}
    let(:auth) {"BASIC c2hpbnlhbmRjaHJvbWU6YXF1YWNvbGE="}
    let(:subscription_id) {3}
    let(:source_id) {44}
    let(:sub_source_id) {666}

    describe "get_properties" do
      it "makes a Get Properties Request" do
        expect(GetPropertiesRequest).to receive(:execute).with(auth, url, subscription_id)
        client.get_properties
      end
    end

    describe "get_property" do
      it "makes a Get Property Request" do
        expect(GetPropertyRequest).to receive(:execute).with(auth, url, subscription_id, 1)
        client.get_property(1)
      end
    end

    describe "post_lead" do
      it "makes a Post Lead Request" do
        expect(PostLeadRequest).to receive(:execute).with(auth, url, source_id, sub_source_id, 1, {})
        client.post_lead(1,{})
      end
    end

    describe "get_leads_for_property" do
      it "makes a Get Leads For Property Request" do
        expect(GetLeadsForPropertyRequest).to receive(:execute).with(auth, url, subscription_id, 1)
        client.get_leads_for_property(1)
      end
    end

    describe "get_lead" do
      it "makes a Get Lead Request" do
        expect(GetLeadRequest).to receive(:execute).with(auth, url, subscription_id, 1, 2)
        client.get_lead(1,2)
      end
    end


  end

end