require 'spec_helper'

module G5YglClient20
  describe PostLeadRequest do
    let(:url) {"https://www.youvegotleads.com/api/properties/"}
    let(:auth) {"BASIC c2hpbnlhbmRjaHJvbWU6YXF1YWNvbGE="}
    let(:subscription_id) {3}
    let(:source_id) {588}
    let(:sub_source_id) {666}

    describe 'execute' do
      it "calls HTTParty post without RootLeadSource" do
        expect(HTTParty).to receive(:post).with("#{url}1/leads",
                                                :headers => {"Authorization" => auth,
                                                             "Host" => HOST,
                                                             "Accept" => "application/json",
                                                             "Content-Type" => "application/json"},
                                                :body=>"{\"PrimaryContact\":{\"FirstName\":\"mad\",\"LastName\":\"max\",\"Address\":{\"Email\":\"mad@max.com\",\"PhoneCell\":\"5418675309\"}},\"CallCenterId\":\"G5-50\",\"Notes\":{\"Notes\":\"Witness Me\"},\"ReferralSources\":[{\"LeadSourceId\":\"588\",\"LeadSourceRank\":\"1\"}]}")

        PostLeadRequest.execute(auth, url, source_id, nil, 1, {first_name: "mad",
                                                               last_name: "max",
                                                               email: "mad@max.com",
                                                               phone: "5418675309",
                                                               notes: "Witness Me",
                                                               id: 50})
      end

      it "calls HTTParty post with RootLeadSource" do
        expect(HTTParty).to receive(:post).with("#{url}1/leads",
                                                :headers => {"Authorization" => auth,
                                                             "Host" => HOST,
                                                             "Accept" => "application/json",
                                                             "Content-Type" => "application/json"},
                                                :body=>"{\"PrimaryContact\":{\"FirstName\":\"mad\",\"LastName\":\"max\",\"Address\":{\"Email\":\"mad@max.com\",\"PhoneCell\":\"5418675309\"}},\"CallCenterId\":\"G5-50\",\"Notes\":{\"Notes\":\"Witness Me\"},\"ReferralSources\":[{\"LeadSourceId\":\"666\",\"LeadSourceRank\":\"1\",\"RootLeadSourceId\":\"588\"}]}")

        PostLeadRequest.execute(auth, url, source_id, sub_source_id, 1, {first_name: "mad",
                                                                         last_name: "max",
                                                                         email: "mad@max.com",
                                                                         phone: "5418675309",
                                                                         notes: "Witness Me",
                                                                         id: 50})
      end

    end

  end
end